# WEB+DB PRESS Vol.110 連載「Perl Hackers Hub」サンプルコード
技術評論社刊「WEB+DB PRESS Vol.110」の連載「Perl Hackers Hub」第55回
「Perlコードの高速化」（東邦之著）のサンプルコードです。

検証に使用した環境
-------------------------------------------------------------------------------
- OS
    - macOS Sierra (10.12.6)
- Perl
    - Perl 5.18.2 (上記macOSの`/usr/bin/perl`)
    - Perl 5.22.1 (〃でソースビルドした`/usr/local/bin/perl`)
    - Perl 5.28.1 (〃でソースビルドした`/opt/bin/perl`)

サンプルコードの実行に必要な環境
-------------------------------------------------------------------------------
- Perl 5.10.1以上
- コアモジュール
    - `Benchmark`
    - `Test::More`
- 別途インストールが必要なモジュール
    - `Devel::Size`
        - `cpanm Devel::Size`
        - データ構造のベンチマークで例示しているコードのみ
    - `Devel::NYTProf`
        - `cpanm Devel::NYTProf`
        - プロファイリングを行う場合のみ

実行方法
-------------------------------------------------------------------------------
いずれのサンプルコードも引数にファイル名を渡して`perl`を実行するだけです。

```
$ perl ./s-vs-y.pl
ok 1
ok 2
Perl v5.28.1 on darwin
--------------------------------------------------
          Rate s/// y///
s///  886263/s   -- -77%
y/// 3896104/s 340%   --
1..2
```

文字列
-------------------------------------------------------------------------------
- [特定文字の削除にはy///を使う - s-vs-y.pl](s-vs-y.pl)
- [先頭文字の確認にはindex()を使う - check-the-first-character.pl](check-the-first-character.pl)
- [文字列の先頭・末尾の確認にはindex()とsubstr()を使う - is-email-address-or-not.pl](is-email-address-or-not.pl)
- [文字列の比較にはlc()を使う - lc-vs-i-modifier-vs-char-class.pl](lc-vs-i-modifier-vs-char-class.pl)
- [メタ文字を含む正規表現は読みやすいものを使う - scape-vs-char-class-vs-qe.pl](scape-vs-char-class-vs-qe.pl)

データ構造
-------------------------------------------------------------------------------
- [ある値が一覧に含まれるかはexists()を使う - grep-list-vs-exists-hash.pl](grep-list-vs-exists-hash.pl)
    - [上記を大きな配列とハッシュで検証したコード - grep-list-vs-exists-hash-100.pl](grep-list-vs-exists-hash-100.pl)
    - 変数のサイズを出力するには`Devel::Size`モジュールが必要です
    - `eval { require Devel::Size }`としているので`Devel::Size`が無くてもエラーにはなりません
- [要素数の少ないデータには配列を使う - array-vs-hash.pl](array-vs-hash.pl)
- [エラーメッセージの照合には配列を使う - check-smtp-error-message.pl](check-smtp-error-message.pl)
    - 変数のサイズを出力するには`Devel::Size`モジュールが必要です
    - `eval { require Devel::Size }`としているので`Devel::Size`が無くてもエラーにはなりません
- [配列の末尾を参照するには負の添え字を使う - dollar-sharp-vs-negative-index.pl](dollar-sharp-vs-negative-index.pl)
- [ループ処理にはforeachを使う - for-vs-foreach-vs-while.pl](for-vs-foreach-vs-while.pl)
    - [whileをforeachで書き換えると失敗する例 - fails-on-foreach-loop.pl](fails-on-foreach-loop.pl)


他のベンチマークコード
===============================================================================
[筆者のベンチマーク用リポジトリ](https://github.com/azumakuniyuki/make-perl-code-faster)には
本誌で紹介できなかったベンチマークコードが多数ありますので、興味のある方はご覧ください。

