#!/usr/bin/env perl
# @v vs. %v
use strict;
use warnings;
use Benchmark ':all';
use Test::More 'no_plan';

my $A = [
    'final-recipient',
    'rfc822',
    'neko@nyaan.jp'
];
my $H = {
    'field' => 'final-recipient',
    'type'  => 'rfc822',
    'value' => 'neko@nyaan.jp'
};
my $Text = 'final-recipient: neko@nyaan.jp';

sub ar { return $A->[0].': '.$A->[2] }
sub hs { return $H->{'field'}.': '.$H->{'value'} }

is ar(), $Text;
is hs(), $Text;

printf("Perl %s on %s\n%s\n", $^V, $^O, '-' x 50);
cmpthese(6e6, {
        '@v' => sub { ar() },
        '%v' => sub { hs() },
    }
);

__END__

Perl v5.18.2 on darwin
--------------------------------------------------
        Rate   %v   @v
%v 2884615/s   -- -10%
@v 3191489/s  11%   --

Perl v5.22.1 on darwin
--------------------------------------------------
        Rate   %v   @v
%v 3296703/s   -- -17%
@v 3973510/s  21%   --

Perl v5.28.1 on darwin
--------------------------------------------------
        Rate   %v   @v
%v 4761905/s   -- -23%
@v 6185567/s  30%   --

