#!/usr/bin/env perl
# $v =~ /\A.../ vs. index(?) x 2
use strict;
use warnings;
use Benchmark ':all';
use Test::More 'no_plan';

my $Status = '550';

sub regexp { return 1 if $Status =~ /\A[45]/ }
sub index2 {
    return 1 if index($Status, '4') == 0;
    return 1 if index($Status, '5') == 0;
}

is regexp, 1;
is index2, 1;

printf("Perl %s on %s\n%s\n", $^V, $^O, '-' x 50);
cmpthese(6e6, {
        '/\A[45]/' => sub { regexp() },
        'index()'  => sub { index2() },
    }
);

__END__

Perl v5.18.2 on darwin
--------------------------------------------------
              Rate substr() /\A[45]/  index()
substr() 2985075/s       --     -12%     -21%
/\A[45]/ 3389831/s      14%       --     -10%
index()  3773585/s      26%      11%       --

Perl v5.22.1 on darwin
--------------------------------------------------
              Rate substr() /\A[45]/  index()
substr() 3333333/s       --      -8%     -21%
/\A[45]/ 3614458/s       8%       --     -14%
index()  4195804/s      26%      16%       --

Perl v5.28.1 on darwin
--------------------------------------------------
              Rate substr() /\A[45]/  index()
substr() 4081633/s       --      -6%     -17%
/\A[45]/ 4347826/s       7%       --     -12%
index()  4918033/s      20%      13%       --
