#!/usr/bin/env perl
# $v[$#v] vs. $v[-1]
use strict;
use warnings;
use Benchmark ':all';
use Test::More 'no_plan';

my @A = (1..100);

sub ds { return ($A[$#A] + $A[$#A - 1]) }
sub ni { return ($A[-1] + $A[-2]) }

is ds(), 199;
is ni(), 199;

printf("Perl %s on %s\n%s\n", $^V, $^O, '-' x 50);
cmpthese(6e6, {
        '$v[$#v]' => sub { ds() },
        '$v[-1]'  => sub { ni() },
    }
);

__END__

Perl v5.18.2 on darwin
--------------------------------------------------
             Rate $v[$#v]  $v[-1]
$v[$#v] 2666667/s      --    -36%
$v[-1]  4195804/s     57%      --

Perl v5.22.1 on darwin
--------------------------------------------------
             Rate $v[$#v]  $v[-1]
$v[$#v] 3389831/s      --    -44%
$v[-1]  6060606/s     79%      --

Perl v5.28.1 on darwin
--------------------------------------------------
              Rate $v[$#v]  $v[-1]
$v[$#v]  4838710/s      --    -56%
$v[-1]  10909091/s    125%      --

