#!/usr/bin/env perl
# $v[$#v] vs. $v[-1]
use strict;
use warnings;
use Benchmark ':all';
use Test::More 'no_plan';

my @A = (1..100);
my $S = $#A;

sub ds { return ($A[$S] + $A[$S - 1]) }
sub ni { return ($A[-1] + $A[-2]) }

is ds(), 199;
is ni(), 199;

printf("Perl %s on %s\n%s\n", $^V, $^O, '-' x 50);
cmpthese(6e6, {
        '$v[$s]' => sub { ds() },
        '$v[-1]' => sub { ni() },
    }
);

__END__

Perl v5.18.2 on darwin
--------------------------------------------------
            Rate $v[-1] $v[$s]
$v[-1] 4081633/s     --    -3%
$v[$s] 4225352/s     4%     --

Perl v5.22.1 on darwin
--------------------------------------------------
            Rate $v[$s] $v[-1]
$v[$s] 4477612/s     --   -16%
$v[-1] 5357143/s    20%     --

Perl v5.28.1 on darwin
--------------------------------------------------
             Rate $v[$s] $v[-1]
$v[$s]  8000000/s     --   -27%
$v[-1] 10909091/s    36%     --

