#!/usr/bin/env perl
# Fails on foreach loop
use strict;
use warnings;
use Benchmark ':all';
use Test::More 'no_plan';

# https://github.com/sisimai/p5-Sisimai/blob/master/set-of-emails/maildir/bsd/email-v5sendmail-01.eml
my $EntireEmail = 'Return-Path: <MAILER-DAEMON@example.com>
Received: from mx1.example.com ([192.0.2.55])
    by mx5.example.net (Post.Office MTA v3.1.2 release (FF000-0000) ID# 0-00000000000000000)
    with SMTP id 00000000 for <shironeko@example.co.jp>;
    Thu, 29 Apr 1998 23:34:45 -0700
Received: by mx5.example.com; (5.65/1.37) id 0000000;
    Sat, 29 Apr 1995 23:34:45 +0900
Date: Sat, 29 Apr 1995 23:34:45 +0900
From: Mail Delivery Subsystem <MAILER-DAEMON@example.com>
Subject: Returned mail: Cannot send message for 4 days
Message-Id: <0000000000.0000000@mx5.example.com>
To: shironeko@example.co.jp

   ----- Transcript of session follows -----
421 example.com (smtp)... Deferred: Connection timed out during user open with example.com

   ----- Unsent message follows -----
Received: by mx9.example.com; (5.65/1.37) id 0000000;
    Thu, 29 Apr 1995 23:34:45 +0900
From: shironeko@example.co.jp
To: kijitora@example.com
Subject: Nyaaan

Nyaaaaaaaaaaaaaaaan
';

sub wloop {
    my @p = split(/\n/, $EntireEmail);
    my $v = [];

    while( my $e = shift @p ) {
        push @$v, $e;
    }
    return $v;
}

sub floop {
    my @p = split(/\n/, $EntireEmail);
    my $v = [];

    foreach my $e ( @p ) {
        # 次の行を入れないとwloopと同じ動作にならない
        # last unless length $e;
        push @$v, $e;
    }
    return $v;
}

is scalar @{ wloop() }, 12, 'while() return email headers only';
is scalar @{ floop() }, 12, 'foreach() return email headers and body';

