#!/usr/bin/env perl
# /A/i vs. /[Mm/
use strict;
use warnings;
use Benchmark ':all';
use Test::More 'no_plan';

my $Text = 'Mailer-Daemon';

sub im { return 1 if $Text =~ /mailer-daemon/i }
sub cc { return 1 if $Text =~ /[Mm]ailer-[Dd]aemon/ }

is im, 1;
is cc, 1;

printf("Perl %s on %s\n%s\n", $^V, $^O, '-' x 50);
cmpthese(6e6, {
        '=~ /.../i' => sub { im() },
        '=~ /[Mm]/' => sub { cc() },
    }
);

__END__

Perl v5.18.2 on darwin
--------------------------------------------------
               Rate =~ /[Mm]/ =~ /.../i
=~ /[Mm]/ 2076125/s        --      -25%
=~ /.../i 2777778/s       34%        --

Perl v5.22.1 on darwin
--------------------------------------------------
               Rate =~ /[Mm]/ =~ /.../i
=~ /[Mm]/ 2298851/s        --      -18%
=~ /.../i 2803738/s       22%        --

Perl v5.28.1 on darwin
--------------------------------------------------
               Rate =~ /.../i =~ /[Mm]/
=~ /.../i 2586207/s        --       -2%
=~ /[Mm]/ 2631579/s        2%        --

